// C Source File
// Created 3/23/2002; 4:56:03 PM
// YES, I KNOW IT IS INEFFICENT. I really don't care much. I just wanted to make the thing,
// be glad (or sad, if you use it) that it even exists. And this is still better than TI-Basic.
// Oh yes, this is copyleft under the GNU GPL included in the zip. There is no warranty. I am not
// responsible for any damages this may cause. However, I will try to help you repair them, and at
// least to fix the bug that caused them.  Also, many thanks to the TICT for the great documentation
// and routines used in this file. (InputStr, the returning string, and a few other things are
// taken from their help files. Read em, they rule.

#define USE_TI89              // Produce .89z File
#define USE_TI92PLUS          // Produce .9xz File
#define RETURN_VALUE          // Returns a value.
#define SAVE_SCREEN           // Save/Restore LCD Contents
#include <tigcclib.h>         // Include All Header Files

void InputStr (char *buffer, short maxlen)
{
  SCR_STATE ss;
  short key, i = 0;
  buffer[0] = 0;
  SaveScrState (&ss);
  do
    {
      MoveTo (ss.CurX, ss.CurY);
      printf ("%s_  ", buffer);
        // Two spaces are required if F_4x6 font is used
      key = ngetchx ();
      if (key >= ' ' && key <= '~' && i < maxlen) buffer[i++] = key;
      if (key == KEY_BACKSPACE && i) i--;
      buffer[i] = 0;
    } while (key != KEY_ENTER);
}


// Main Function
int _main()
{
	// Place your code here.
	ESI argptr=top_estack;
	while (GetArgType (top_estack) !=END_TAG)
  top_estack=next_expression_index (top_estack);
  top_estack--;
	clrscr();           //clears the screen
	char s[10000];      //variable declarations. s is the string length, if it is bigger than 10k, they wouldn't (shouldn't) be using a calc
	s[0]='\0';
	char i[15];         //input file name
	i[0]='\0';
	char o[15];         //output file name
	o[0]='\0';
	int b=9999;         //list length
	short c;
	printf("\nEnter source file name.\n");
	InputStr(i,15);
	FILE *f;            //file input reading, below opens input file
	f = fopen (i, "r");
	if (ferror(f)!=0)
	{
		fclose(f);
	  char string[] = "Error, input file does not exist.";
		char *output_string;
		output_string = malloc(strlen(string) + 2);
		//put the zero at the beginning of the string
		output_string[0] = 0;
		//copy the string, including the terminating zero, to the output string
		strcpy(output_string + 1, string);
		//put the string, with all spaces intact, on the expression stack
		push_expr_quantum(output_string + strlen(output_string + 1) + 1, STR_TAG);
		//always make sure to free your memory
		free(output_string);
		return 0;
	}
	printf("\nEnter output file name.\nNote that existing files\nof this name will be\ndeleted.\n");
	InputStr(o,15);
	printf("\nEnter array length.\n");
	InputStr(b,15);
	strcat(s,"Define ");
	strcat(s,o);
	strcat(s,"()=Prgm");
	strcat(s,":NewProb");
	strcat(s,":Local a,p,c");
	strcat(s,":1a:1p:newList(b)a");
	while ((c=fgetc(f))!=EOF)
	{
		if (c=='<')
		{
			strcat(s,":p-1p");
		}
		else if (c=='>')
		{
			strcat(s,":p+1p");
		}
		else if (c=='+')
		{
			strcat(s,":a[p]+1a[p]");
		}
		else if (c=='-')
		{
			strcat(s,":a[p]-1a[p]");
		}
		else if (c==',')
		{
			strcat(s,":Input c");
			strcat(s,":ca[p]");
		}
		else if (c=='.')
		{
			strcat(s,":Disp a[p]");
		}
		else if (c=='[')
		{
			strcat(s,":While a[p]/=0");
		}
		else if (c==']')
		{
			strcat(s,":EndWhile");
		}
	}
	strcat(s,":EndPrgm");
	fclose(f);
	//output program to bfout file
	FILE *fout;
	fout = fopen (o, "wb");
	fputc(0,fout);
	fputs(s,fout);
	fputc(0,fout);
	fputc(STR_TAG,fout);
	fclose(fout);
	printf("Run ");
	printf(o);
	printf("() for your program.\n");
	return 0;
}
